<?PHP
// Copyright (c) 2003 ars Cognita, Inc., all rights reserved
/********************************************************************************

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*******************************************************************************/
/**
 * Create a mindmeld database
 *
 * @author		$Author: richtl $
 * @version		$Revision: 938 $
 * @copyright	2003, ars Cognita, Inc., all rights reserved
 *
 * @package installer
 */
 
 define( 'DEF_INIFILE', 'defaults.ini' );
 
if( is_readable( DEF_INIFILE ) ) {
	$defaults = parse_ini_file( DEF_INIFILE );
} else {
	print "<H3>You need to create a <em>defaults.ini</em> file with the following lines:</H3>";
	print "<UL><LI>dbType = <em>{mysql|postgres|mssql|etc...}</em>";
	print "<LI>dbHost = <em>{servername}</em>";
	print "<LI>dbPort = <em>{port#}</em> <B>OPTIONAL</B>";
	print "<LI>dbUser = <em>{username}</em>";
	print "<LI>dbPass = <em>{password}</em>";
	print "<LI>adodb = <em>{path to adodb library directory}</em>";
	print "<LI>sqlDebug = <em>TRUE</em> <B>OPTIONAL</B></UL>";
}

/**
 * Pull the appropriate values from globals or defaults
 *
 * @param string $name Name of variable to pull
 * @return string Value of requested variable
 */
function getVal( $name ) {
	
	global $defaults;
	
	if( isset( $_POST[$name] ) ) {
		return $_POST[$name];
	}
	if( isset( $defaults[$name] ) ) {
		return $defaults[$name];
	}
	return NULL;
}

$adodb = getVal( 'adodb' );
$dbType = getVal( 'dbType' );
$dbHost = getVal( 'dbHost' );
$dbPort = getVal( 'dbPort' );
$dbName = getVal( 'dbName' );
$dbUser = getVal( 'dbUser' );
$dbPass = getVal( 'dbPass' );
$sqlDebug = getVal( 'sqlDebug' );
$dbCreate = getVal( 'dbCreate' );

if (!defined( '_ADODB_LAYER' ) ) {
	/**
	 * Include the main ADODB library
 	 */
	require( $adodb . '/adodb.inc.php' );
	
	/**
	 * Include the ADODB xmlschema library
 	 */
	require( $adodb . '/adodb-xmlschema.inc.php' );
}

// Interpret and process the submit button
isset( $_POST['submit'] ) ? ( $submit = $_POST['submit'] ) : ( $submit = '' );

switch( $submit ) {
	case "Submit Query":
	
			// Create the connection 
			$dbconn = &ADONewConnection( $dbType );
			$dbconn->debug = $sqlDebug;
			$dbconn->Connect( $dbHost, $dbUser, $dbPasswd );
			
			if( isset( $dbCreate ) ) {
				// Create the database (if requested)
				$html = "<LI>Creating database $dbUser on $dbHost... ";
    			$dict = NewDataDictionary( $dbconn );
    			$dbconn->Connect( $dbHost, $dbUser, $dbPass );
    			$sqlCreate = $dict->CreateDatabase( $dbName );
    			$dbconn->Execute( $sqlCreate[0] );
    			$dict->SetSchema( $dbName );
    			$html .= "done</LI>";
			}
			
			// Populate the database
			$dbconn->Connect( $dbHost, $dbUser, $dbPasswd, $dbName );
			$schema = new adoSchema( $dbconn );
			
			$sql = $schema->ParseSchema( "build_mindmeld.xml" );
			$success = $schema->ExecuteSchema( $sql );
			$schema->Destroy();
		break;
		
	default:
		
		$$dbType = 'SELECTED';
		
		// Show the initial form
		$html = "<HEAD>"
			. "<TITLE>Create a Mindmeld Database</TITLE>"
			. "</HEAD>"
			. "<BODY>"
			. "<H1>Mindmeld Database Creation Tool</H1>"
			. "<P>Enter the information necessary to create and populate"
			. "your new Mindmeld database.</P>"
			. "<form method='POST' action='{$_SERVER['SCRIPT_NAME']}'>"
			. "<table border='0' align='left' cellspacing='1' cellpadding='1'>"
			. "<tr>"
			. "<td> Database Platform </td>"
			. "<td> <select name='dbType'>"
			. "	<option value='mysql' $mysql>MySQL</option>"
			. "	<option value='postgres7' $postgres7>PostgreSQL</option>"
			. "	<option value='mssql' $mssql>MS SQL Server</option>"
			. "	<option value='oci8' $oci8>Oracle</option>"
			. "</select>"
			. "</td>"
			. "<tr>"
			. "<td> Server Host </td>"
			. "<td> <input name='dbHost' value='$dbHost' /></td>"
			. "<td> Port </td>"
			. "<td> <input name='dbPort' size=4 value='$dbPort' /></td>"
			. "</tr>"
			. "<tr>"
			. "<td> Database Name</td>"
			. "<td> <input name='dbName' value='$dbName' /></td>"
			. "</tr>"
			. "<tr>"
			. "<td> User Name</td>"
			. "<td> <input name='dbUser' value='$dbUser' /></td>"
			. "</tr>"
			. "<tr>"
			. "<td> Password </td>"
			. "<td> <input type='password' name='dbPass' /></td>"
			. "</tr>"
			. "<tr>"
			. "<td>Create Database Instance</td>"
			. "<td><input type='checkbox' name='dbCreate' value=true checked></td>"
			. "<td/><td><input type='submit' name='submit' value='Submit Query' /></td>"
			. "</tr>"
			. "</table>"
			. "</form>"
			. "</BODY>";
			
		print $html;	
}

?>