<?PHP
// Copyright (c) 2001-2006 ars Cognita, Inc., all rights reserved
/********************************************************************************
		
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*******************************************************************************/
/**
 * Mindmeld API example
 * 
 * Example of how to contribute new information to Mindmeld using the Mindmeld 
 * API.
 * 
 * Created Mar 4, 2006 by richtl
 *  
 * @author		richtl
 * Last Editor:	$Author: richtl $
 * @version		$Revision: 1.85 $
 * 
 * @package examples
 */

/**
 * Configure Mindmeld
 */
$MM_GLOBALS['home'] = '/mindmeld_directory/';
$MM_GLOBALS['cache'] = '/writeable_cache_directory/';
$MM_GLOBALS['adodb'] = '/mindmeld_directory/opensource/adodb/';
$MM_GLOBALS['dbType'] = 'mysql';
$MM_GLOBALS['dbUser'] = 'mindmeld';
$MM_GLOBALS['dbPass'] = 'mindmeld_password';
$MM_GLOBALS['dbHost'] = 'localhost';
$MM_GLOBALS['dbName'] = 'mindmeld';

/**
 * Load Mindmeld libraries
 */
require_once( $MM_GLOBALS['home'] . 'include/utilities.inc' );
require_once( $MM_GLOBALS['home'] . 'include/mind.inc.php' );

// The mindmeld object creates the ADOdb database connection
// and provides basic methods for working with knowledge objects.
$mindmeld = new mindmeld( 
		NULL,
		$MM_GLOBALS['dbType'],
		$MM_GLOBALS['dbHost'],
		NULL,
		$MM_GLOBALS['dbName'],
		$MM_GLOBALS['dbUser'],
		$MM_GLOBALS['dbPass']
		);

// Mindmeld stores answers as "thoughts."
// Let's contribute a new thought. The SUMMARY is 
// the title of the new thought and is usually 
// provided by the user in an HTML form.
$summary = "Where to find moose in New Hampshire";

// The DETAIL is the body of the new thought
// and is also provided by the user in an HTML form.
$detail = "Moose can be found in boggy areas in the "
	. "Northern regions. It is best to look for them "
	. "at <em>daybreak</em> and <em>dusk</em>.";

// The KEYWORDS argument is optional because Mindmeld
// generates connections automatically. However, it does
// provide a good way to "seed" the initial learning. 
// Keywords can be in the form of words, sentences, or whatever.
$keywords = "Antlers, moosewatching";

// Submit the new knowledge object using a mind facade object. The 
// learnThoughtPreweighted method returns a unique ID if the thought
// is created successfully.
$mind = new mind();
if( !$id = $mind->learnThoughtPreweighted( $summary, $detail, $keywords ) ) {
	die( 'Failed to create the new thought' );
}

// Now fetch and view the thought. To manipulate a thought directly, 
// we need to create a thought object.
$thought = new thought();
$thought->readThoughtFull( $id );  // Fetches the full thought object.
#$thought->readThoughtQuick( $id ); // Only fetches the summary, status, and timestamp. Use it for generating lists.

print "<ul>";
print "<li>ID: {$thought->getThoughtId()}</li>";
print "<li>Title: {$thought->getSummary()}</li>";
print "<li>Body: {$thought->getDetail()}</li>";
print "<li>Status: {$thought->getStatus()}</li>";
print "<li>Updated: {$thought->getInteracted()}</li>";
print "</ul>";

// Destroy the mindmeld object when we're finished with it.
$mindmeld->close();
?>
