<?PHP
// Copyright (c) 2001-2003 ars Cognita, Inc., all rights reserved
/********************************************************************************

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*******************************************************************************/
/**
 * GUI classes for basic HTML/Smarty interface
 *
 * The handler and GUI are provided by the specific interface.
 *
 * @author			$Author: $
 * @version		$Revision: 1213 $
 * @copyright	&copy; 2001-2003, ars Cognita Inc., all rights reserved
 *
 * @package		interfaces
 */
 
/**
* Require base Smarty class
*/
include_once ( $MM_GLOBALS['smarty_home'] . "Smarty.class.php"  );
include_once ( $MM_GLOBALS['home'] . "include/utilities.inc" );

/**
* Base HTML Interface class
*
* Other interfaces should extend this class, over-riding its methods.
*/
class interface {

	function display_answer( $answer, $cacheAnswer = TRUE ) {
		
		global $MM_GLOBALS;

		logMsg( ">>>API: display_answer", MM_ALL );
		
		if( is_numeric( $answer ) ) {
			// A thought ID was passed. Fetch the object.
			logMsg( "Preparing to display answer $answer", MM_INFO );
			include_once( $MM_GLOBALS['home'] . "include/cortex.inc.php" );
			
			$thought = new thought();
			if( !$thought->readThoughtFull( $answer ) ) {
				// Answer doesn't exist.
				logMsg( "Unable to locate thought $answer", MM_WARN );
				return NULL;
			}
			
		} elseif( is_a( $answer, 'thought' ) ) {
			// A thought object was passed
			$thought = $answer;
			
		} else {
			// Don't know what the hell was passed.
			logMsg( "Invalid arguement passed for answer", MM_WARN );
			return NULL;
		}
		
		// Have a thought object. Call plugins, then use Smarty to display it.
		
		// PLUGIN HOOK: Manipulate the thought prior to display
		$thought = $thought->pluginMgr->executePlugins( 'displayThought_html_prefilter', $thought );
		
		logMsg( "Calling template to display thought $answer", MM_INFO );
		// Create and display the HTML template.
		$template = new mmHtmlTemplate;

		$template->assign_by_ref( "thoughtId", $thought->getThoughtId() );
		$template->assign_by_ref( "summary", $thought->getSummary() );
		$template->assign_by_ref( "detail", $thought->getDetail() );	
		$template->display( "interface_display_answer.tpl" );
		
		logMsg( "<<<API: display_answer", MM_ALL );
	}
	
	function update_answer( $answer ) {
		global $MM_GLOBALS;
		
		if( !is_a( $answer, 'thought' ) ) {
			// Not a thought object
			return NULL;
		}
		
		// Update the object in the database from the existing object
		include_once( $MM_GLOBALS['home'] . "include/cortex.inc.php" );
			
		$thought = new thought();
		$thought->updateThought( $answer );
	}
}