<?PHP
// Copyright (c) 2002-2003 ars Cognita, Inc., all rights reserved **/
/********************************************************************************
	
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*******************************************************************************/
/**
 * Mindmeld theme engine
 *  
 * @author		$Author: $
 * @version		$Revision: 1213 $
 *
 * @package interfaces
 */

/**
 * Load and parse a theme
 *
 * @param string $themeName Name of theme directory
 * @return array Theme array
 */
function loadTheme( $themeName = NULL ) {
	
	global $MM_GLOBALS;
	
	// Use the theme from the config file if no theme is specified.
	if ( !$themeName && $MM_GLOBALS['theme'] ) $themeName = $MM_GLOBALS['theme'];
	
	if ( !$themeName ) return NULL;
	
	$themePath = $MM_GLOBALS['webhome'] . "themes/$themeName/";
	$imagePath = $MM_GLOBALS['site'] . "themes/$themeName/images/";

	// Fetch the requested theme
	if ( include( $themePath."theme.php" ) ) {
		
		foreach( $theme as $module => $itemArray ) {
			foreach( $itemArray as $item => $typeArray ) {
				foreach( $typeArray as $type => $value ) {
					
					$themeEntry = $theme[$module][$item][$type];
					switch( strtoupper( $type ) ) {
						case "TEXT":
							break;
						case "STYLE":
							$themeEntry = "STYLE='$themeEntry'";
							break;
						case "IMAGE":
							$themeEntry = "$imagePath".$themeEntry;
							break;
					}
					$theme[$module][$item][$type] = $themeEntry;
				}
			}
		}
		return $theme;
	}
}
?>
