<?PHP
// Copyright (c) 2003 ars Cognita, Inc., all rights reserved
/********************************************************************************

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*******************************************************************************/
/**
 * General data structures for the Smarty HTML interface
 *
 * @author		$Author: richtl $
 * @version		$Revision: 855 $
 * @copyright	2003, ars Cognita, Inc., all rights reserved
 *
 * @package interfaces
 * @subpackage smarty
 *
 * @internal
 */

/**
 * Require base Smarty class
 *
 * @package smarty_interface
 * @internal
 */
require_once ( $MM_GLOBALS['smarty_home'] . "Smarty.class.php"  );

/**#@+
 * Validation policy definition
 *
 * @package smarty_interface
 * @internal
 */
define( 'VALID_QUERY_ID', 'TYPE=INT|MIN=0|MAXLENGTH=9' );
define( 'VALID_THE_QUESTION', 'MAXLENGTH=255' );
define( 'VALID_THOUGHT_ID', 'TYPE=INT|MIN=0|MAXLENGTH=9' );
define( 'VALID_THOUGHT_SUMMARY', 'MAXLENGTH=255' );
define( 'VALID_THOUGHT_DETAIL', 'MAXLENGTH=10000' );
define( 'VALID_HAVE_FEEDBACK', 'MAXLENGTH=20' );
define( 'VALID_EDIT', 'MAXLENGTH=20' );
/**#@-*/

/**
* Return the requested handler state given an list of submit values
*
* Given an assoc array of submit values and states, find the first
* submit value that exists in the superglobals array and return its
* associated state. There are two special states: UNSET, that returns
* NULL, and VALUE, that returns the value of the submit rather than
* an associated state.
*
* @param array		$submits		Assoc array of submits/states
* @return string	Requested state, submit value, or NULL
*/
function setState( $submits ) {
	// Cycle through the allowed submits until we get a match
	foreach( $submits as $key => $value ) {
		if( fetchGlobal( $key ) or fetchGlobal( $key . '_x' ) != NULL ) {
			switch( $value ) {
				case "UNSET":
					return NULL;
					break;
				case "VALUE":
					return fetchGlobal( $key );
					break;
				default:
					return $value;
			}
		}
	}
}

/**
* Build and display the the HTML header
*
* @param object $display Display object containing header properties.
*/
function mmsmarty_showHeader( $display ) {
	
	$template = new mmHtmlTemplate;
	
	if( isset( $display->headerTitleTag ) ) 
		$template->assign_by_ref( "headerTitleTag", $display->headerTitleTag );
		
	if( isset( $display->headerMetaTags ) ) 
		$template->assign_by_ref( "headerScriptTags", $display->headerMetaTags );
		
	if( isset( $display->headerScriptTags ) ) 
		$template->assign_by_ref( "headerScriptTags", $display->headerScriptTags );
		
	if( isset( $display->headerStyleTags ) ) 
		$template->assign_by_ref( "headerStyleTags", $display->headerStyleTags );
	
	if( isset( $display->headerMiscTags ) ) 
		$template->assign_by_ref( "headerScriptTags", $display->headerMiscTags );
	
	$template->display( "header.tpl" );
}

// NOTE: Only used by PostNuke at the moment
function pageHeader() {
	@include("header.php");
	if ( function_exists( 'OpenTable' ) ) OpenTable();
}

// NOTE: Only used by PostNuke at the moment
function pageFooter() {
	if ( function_exists( 'CloseTable' ) ) CloseTable();
	@include("footer.php");
}

function debugSession( $debug = FALSE ) {
	
	global $MM_GLOBALS;
	
	if ( $MM_GLOBALS['debug'] >= 5 or $debug ) {
		print "<TABLE STYLE='font-size: smaller' BORDER=2 BGCOLOR=#FFCCCC CELLPADDING=4>";
		print "<TR><TH>Session " . session_name() . "</TH><TH ALIGN=LEFT>" . SID . "</TH></TR>";
		print "<TR><TH>_SESSION</TH><TD><PRE>";
		print_r( $_SESSION );
		print "</PRE></TD></TR><TR><TH>_GET</TH><TD><PRE>";
		print_r( $_GET );
		print "</PRE></TD></TR><TR><TH>_POST</TH><TD><PRE>";
		print_r( $_POST );
		print "</PRE></TD></TR><TR><TH>_COOKIE</TH><TD><PRE>";
		print_r( $_COOKIE  );
		print "</PRE></TD></TR></TABLE>";
	}
}
?>
