{strip}{ *
<!--******************************************************************************
	Copyright (c) 2001 ars Cognita, Inc., all rights reserved
	*********************************************************

 manage_getUpdate.tpl 

 HTML template to fetch and update and existing thought. the "getId" form 
 performs the specified form action, returning the thoughtID to update. The
 "learn" form gets updated content from the user. The "upload" form uploads
 a file from the user's harddrive into the thought detail.
 
 DO NOT EDIT ANYTHING BETWEEN CURLY BRACES!
 
 @package		Manage Content
 @subpackage	HTML Presentation
 
 @param boolean	$preview		Display preview without committing
 @param	integer	$thoughtId		ID of displayed answer
 @param	string	$urlSelf		Action for "update" form
 	TODO: Change to variable-assigned form action
 @param	string	$thoughtSummary		Summary of displayed answer
 @param	string	$thoughtDetail		HTML detail of displayed answer

 @return	string	$submit		"Submit Update" or "Load" (for file upload)
 
 @author:		$Author: richtl $s
 @version:		$Revision: 810 $

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*****************************************************************************-->
* }{/strip}
{if $plugin_initBody}
<BODY {$plugin_initBody}>
{/if}
{if $preview}
	{if $theme.manage.preview_heading.text} {* Theme *}
		<DIV {$theme.manage.preview_heading.style}>{$theme.manage.preview_heading.text}</DIV>
	{else} {* Default *}
		<H2>Preview Your Changes</H2>
	{/if}

	{if $theme.search.answer_id.text}
		<P {$theme.search.answer_summary.style}>{$theme.search.answer_id.text}{$thoughtId}
		{$theme.search.answer_summary.text}{$thoughtSummary|escape:"htmlall"}</P>
	{else}
		<H2>#{$thoughtId}: {$thoughtSummary|escape:"htmlall"}</H2>
	{/if}
	{if $theme.search.answer_detail.style}
		<P {$theme.search.answer_detail.style}>{$thoughtPreview}</P>
	{else}
		<P>{$thoughtPreview}</P>
	{/if}

	<HR>
{else}
	{if $theme.manage.edit_heading.text} {* Theme *}
		<DIV {$theme.manage.edit_heading.style}>{$theme.manage.edit_heading.text}{$thoughtId}</DIV>
	{else} {* Default *}
		<H2>Updating Answer #{$thoughtId}</H2>
	{/if}
{/if}

{if $editorEnabled }
	<!-- WYSISYG Editor plugin -->
<SCRIPT type="text/javascript" src="{$site}tools/htmlarea/htmlarea.js"></SCRIPT>
<SCRIPT type="text/javascript" src="{$site}tools/htmlarea/htmlarea-lang-en.js"></SCRIPT>
<SCRIPT type="text/javascript" src="{$site}tools/htmlarea/dialog.js"></SCRIPT>

{literal}

<SCRIPT type="text/javascript">
	<!-- Hide the jscript
	var editor = null;
	
	function initEditor() {
		editor = new HTMLArea("thoughtDetail");
		editor.generate();
	}
		
	function insertHTML() {
		var html = prompt("Enter some HTML code here");
		if (html) {
			editor.insertHTML(html);
		}
	}
	
	function highlight() {
		editor.surroundHTML('<span style="background:yellow">', '</span>');
	}
	-->
</SCRIPT>
{/literal}
{/if}{* Editor Enabled *}

<FORM NAME="update" METHOD=POST ACTION="{$urlSelf}">
	<INPUT TYPE=HIDDEN NAME="thoughtId" VALUE="{$thoughtId}"/>
	
	<TABLE BORDER=0 CELLSPACING=4 CELLPADDING=0>
		<TR VALIGN=MIDDLE>
			<TD> {* Summary Section *}
				{if $theme.manage.summary_description.text} {* Theme *}
					<DIV {$theme.manage.summary_description.style}>{$theme.manage.summary_description.text}</DIV>
				{else} {* Default *}
					<EM>Enter the Question</EM><BR>
				{/if}
				<INPUT TYPE=TEXT NAME="thoughtSummary" SIZE=60 MAXLENGTH=255 VALUE="{$thoughtSummary}"/>
			</TD>
			<TD VALIGN=BOTTOM>
				{if $theme.contrib.summary_help_button.image} {* Show button with theme image *}
					<A HREF="{$site}doc/userguide/x64.html" TARGET="_blank"><IMG {$theme.contrib.summary_help_button.style} SRC="{$theme.contrib.summary_help_button.image}" BORDER=0 ALT="Help!"/></A>
				{elseif $theme.contrib.summary_help_button.text} (* Show button with theme text *}
					<A HREF="{$site}doc/userguide/x64.html" TARGET="_blank">{$theme.contrib.summary_help_button.text}</A>
				{else} {* Show default button *}
					<A HREF="{$site}doc/userguide/x64.html" TARGET="_blank">Help!</A>
				{/if}
			</TD>
		</TR>
		<TR><TD>&nbsp;</TD></TR>
		<TR>
		<TD COLSPAN=2> {* Detail Section *}
				{if $theme.manage.detail_description.text} {* Theme *}
					<DIV {$theme.manage.detail_description.style}>{$theme.manage.detail_description.text}</DIV>
				{else} {* Default *}
					<EM>Enter the answer in text or HTML format</EM><BR>
				{/if}
				<TEXTAREA ID="thoughtDetail" NAME="thoughtDetail" COLS=60 ROWS=20 WRAP=SOFT>{$thoughtDetail}</TEXTAREA>
				<!-- TEXTAREA NAME="thoughtDetail" COLS=60 ROWS=20 WRAP=SOFT>{$thoughtDetail}</TEXTAREA -->
			</TD>
		</TR>
		<TR>
			<TD>
				{if $theme.manage.preview_button.image} {* Show button with theme image *}
					<INPUT TYPE=IMAGE NAME="submit_preview" VALUE="Preview" {$theme.manage.preview_button.style} SRC="{$theme.manage.preview_button.image}" BORDER=0 ALT="{$theme.manage.preview_button.text}" onClick="fetchEkitText();"/>
				{else} {* Show default button *}
					<INPUT TYPE=SUBMIT NAME="submit_preview" VALUE="Preview"/>
				{/if}
				{if $theme.manage.update_answer.image} {* Show button with theme image *}
					<INPUT TYPE=IMAGE NAME="submit_update" VALUE="Submit Update" {$theme.manage.update_answer.style} SRC="{$theme.manage.update_answer.image}" BORDER=0 ALT="{$theme.manage.update_answer.text}"/>
				{else} {* Show default button *}
					<INPUT TYPE=SUBMIT NAME="submit_update" VALUE="Submit Update"/>
				{/if}
			</TD>
			<TD ALIGN=RIGHT>
				{if $theme.contrib.detail_help_button.image} {* Show button with theme image *}
					<A HREF="{$site}doc/userguide/x75.html" TARGET="_blank"><IMG {$theme.contrib.detail_help_button.style} SRC="{$theme.contrib.detail_help_button.image}" BORDER=0 ALT="Help!"/></A>
				{elseif $theme.contrib.detail_help_button.text} (* Show button with theme text *}
					<A HREF="{$site}doc/userguide/x75.html" TARGET="_blank">{$theme.contrib.detail_help_button.text}</A>
				{else} {* Show default button *}
					<A HREF="{$site}doc/userguide/x75.html" TARGET="_blank">Help!</A>
				{/if}
			</TD>
		</TR>
	</TABLE>
</FORM>

{* Display file upload form *}
<!--<FORM NAME="upload" METHOD="POST" ACTION="{$urlSelf}" ENCTYPE="multipart/form-data">
	<P><EM>Or upload a file into the detail</EM></P>
	<INPUT TYPE="file" NAME="userfile"></INPUT>
	<INPUT TYPE="submit" NAME="submit" VALUE="Load"></INPUT>
</FORM>-->


