{strip}{ *
<!--******************************************************************************
	Copyright (c) 2001 ars Cognita, Inc., all rights reserved
	*********************************************************

 manage_showResults.tpl 

 HTML template to present the search results list. Show the results list
 as a list of links. Show an appropriate comment if nothing matches.
 
 DO NOT EDIT ANYTHING BETWEEN CURLY BRACES!
 
 @package		Manage Content
 @subpackage	HTML Presentation
 
 @param	string	$headerFile		Name of template file to include as header
 @param	string	$urlSelf		Action for "byId"  and "bySearch" forms
 @param	array	$answers		Array containing possible answers
 @param	integer	$queryId		ID of user's query
 @param	integer	$thoughtId		ID of requested answer
 @param	string	$theQuestion	Search criteria for answers
 
 @return	string	$submit		"Update" or "Start Over"
 
 @author:		$Author: richtl $s
 @version:		$Revision: 629 $

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*****************************************************************************-->
* }
{if count($answers) > 0}
	{if $headerFile}
		{include file=$headerFile}
	{/if}	
{/strip}
	<FORM NAME="manageAction" METHOD=POST ACTION="{$urlSelf}">
	<TABLE WIDTH=95% CELLSPACING=4 CELLPADDING=4 BORDER=0>
		<TR>
			<TH ALIGN="center" {$theme.manage.results_status.style}>
				{if $theme.manage.results_status.text} {* Theme *}
					{$theme.manage.results_status.text}
				{else} {* Default *}
					Status
				{/if}
			</TH>
			<TH ALIGN="center" WIDTH="5%" {$theme.manage.results_id.style}>
				{if $theme.manage.results_id.text} {* Theme *}
					{$theme.manage.results_id.text}
				{else} {* Default *}
					#
				{/if}
			</TH>
			<TH ALIGN="left" WIDTH="100%" {$theme.manage.results_summary.style}>
				{if $theme.manage.results_summary.text} {* Theme *}
					{$theme.manage.results_summary.text}
				{else} {* Default *}
					Summary
				{/if}
			</TH>
			<TD>
				{if $theme.manage.status_reset.image} {* Show button with theme image *}
					<INPUT TYPE=IMAGE {$theme.manage.status_reset.style} NAME="reset" VALUE="Reset" SRC="{$theme.manage.status_reset.image}" ALT="{$theme.manage.status_reset.text}" BORDER=0/>
				{else} {* Show default button *}
					<INPUT TYPE=RESET NAME="Reset" VALUE="Reset"/>
				{/if}
			</TD>
		</TR>
		<TR><TD COLSPAN=4><HR/></TD></TR>
		{section name=searchResults loop=$answers}
			{strip}
			{assign var="thoughtId" value=$answers[searchResults].0}
			{assign var="thoughtSummary" value=$answers[searchResults].1}
			{assign var="thoughtStrength" value=$answers[searchResults].2}
			{assign var="status" value=$answers[searchResults].3}
			
			{if $status == "DRAFT"}
				{assign var="statusColor" value="#FFFF44"}
			{/if}
			
			{if $status == "ACTIVE"}
				{assign var="statusColor" value="#00AA00"}
			{/if}
			
			{if $status == "INACTIVE"} 
				{assign var="statusColor" value="#AAAAFF"}
			{/if}
			
			{if $status == "DELETED"} 
				{assign var="statusColor" value="#AA0000"}
			{/if}
			{/strip}
			<TR>
			<TD ALIGN="center" BGCOLOR="{$statusColor}" {$theme.manage.list_status.style}>
					<SELECT NAME="actionArray[{$thoughtId}]">
					<OPTION VALUE="DRAFT" {if $status == "DRAFT"}SELECTED{/if}>Draft</OPTION>
					<OPTION VALUE="ACTIVE" {if $status == "ACTIVE"}SELECTED{/if}>Allow</OPTION>
					<OPTION VALUE="INACTIVE" {if $status == "INACTIVE"}SELECTED{/if}>Hide</OPTION>
					<OPTION VALUE="DELETED" {if $status == "DELETED"}SELECTED{/if}>Delete</OPTION>
					</SELECT></TD>
				<TD ALIGN="center" {$theme.manage.list_id.style}>{$thoughtId}</TD>
				<TD ALIGN="left" {$theme.manage.list_summary.style}><A HREF="{$baseLink}submit=selection&thoughtId={$thoughtId}&queryId={$queryId}&theQuestion={$theQuestion|escape:"url"}">{$thoughtSummary|escape:"htmlall"}</A></TD>
			</TR>
		{/section}
			<TR><TD COLSPAN=4>&nbsp;</TD></TR>
			<TR>
				<TD COLSPAN=3>
					<INPUT TYPE=HIDDEN NAME="thoughtId" VALUE="{$thoughtId}"/>
					<INPUT TYPE=HIDDEN NAME="queryId" VALUE="{$queryId}"/>
					<INPUT TYPE=HIDDEN NAME="theQuestion" VALUE="{$theQuestion}"/>
			
					{if $theme.manage.status_update.image} {* Show button with theme image *}
						<INPUT TYPE=IMAGE NAME="submit_status" {$theme.manage.status_update.style} SRC="{$theme.manage.status_update.image}" ALT="{$theme.manage.status_update.text}" BORDER=0/>
					{else} {* Show default button *}
						<INPUT TYPE=SUBMIT NAME="submit" VALUE="Update"/>
					{/if}
				</TD>
				<TD ALIGN=RIGHT {$theme.manage.results_help.style}>
				{if $theme.manage.results_help.image} {* Show button with theme image *}
					<A HREF="{$site}doc/userguide/x203.html" TARGET="_blank"><IMG SRC="{$theme.manage.results_help.image}" BORDER=0 ALT="{$theme.manage.results_help.text}"/></A>
				{else} {* Show default button *}
					<A HREF="{$site}doc/userguide/x203.html" TARGET="_blank">Help!</A>
				{/if}
			</TD>
			</TR>
		</TABLE>
	</FORM>
{else}
	{if $theme.manage.results_empty.text} {* Theme *}
		<DIV {$theme.manage.results_empty.style}>{$theme.manage.results_empty.text}</DIV>
	{else} {* Default *}
		<EM>No answers matched your search.</EM>
	{/if}
{/if}
