<?PHP
// Copyright (c) 2003 ars Cognita, Inc., all rights reserved
/********************************************************************************
	
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*******************************************************************************/
/**
 * Core filter plugins for Mindmeld
 *
 * Provides core data filter plugins for mindmeld
 *  
 * @author		$Author: $
 * @version		$Revision: 1213 $
 *
 * @package plugins
 * @subpackage core
 */

/**
 * Plugin to dream
 */
class p50_dream_clearSqlCache extends plugin {
	
    /**
    * Dream-time utility to clear the SQL cache.
    *
	* @param object $dream Dream object
	*/
	function dream( $dream ) {
		
		global $ADODB_CACHE_DIR;
		
		if ( $ADODB_CACHE_DIR ) {
			if ( ! $retirementAge ) {
				$retirementAge = $dream->readParam( 'stale_query_age' );
			}
			
			$dirHandle = dir( $ADODB_CACHE_DIR );
			
			$dream->logMsg( sprintf ( "Cache dir %s, retirement age is %s minutes",
				$dirHandle->path, $retirementAge ), 4 );
			
			$clearedFiles = 0;
			while ( ( $cacheFile = $dirHandle->read() ) !== false ) {
				$pathToFile = $dirHandle->path."/".$cacheFile;
				$fileAge = ( time() - filectime( $pathToFile ) ) / 60;
				if ( $fileAge > $retirementAge && eregi( "^adodb", $cacheFile ) ) {
					unlink( $pathToFile ) ?
						$clearedFiles++ :
						$dream->logMsg( sprintf ( "Unable to delete %s", $pathToFile ), MM_WARN );
				}
			}
			
			$msg = "Cleared $clearedFiles cache files";
			$event = new mmEvent;
			$event->dream( get_class( $this ), $msg  );
			$dream->logMsg( $msg, MM_ALL );
		}
		return NULL;
	}
}
?>