<?PHP
// Copyright (c) 2003 ars Cognita, Inc., all rights reserved
/********************************************************************************
	
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
   
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*******************************************************************************/
/**
 * Core filter plugins for Mindmeld
 *
 * Provides core data filter plugins for mindmeld
 *  
 * @author		$Author: richtl $
 * @version		$Revision: 957 $
 *
 * @package plugins
 * @subpackage core
 */

/**
 * Plugin to automatically format HTML for display
 */
class p85_htmlAutoFormat extends plugin {
	
    /**
     * autoformat for HTML display
     * 
     * Automatically changes newlines in the thought detail to HTML 
     * break tags if no HTML paragraph or break tags are found.
     *
	 * @param object $thoughtObj Thought object
	 * @return object Processed thought object
	 */
	function displayAnswerPrefilter( $thoughtObj ) {

		// The filter
		$detail = $thoughtObj->getDetail();

		if ( !eregi( "<(P|BR).*>", $detail ) ) {
			$detail = nl2br( $detail );
		}
		
		// Update the return object
		$thoughtObj->setDetail( $detail );
		
		return $thoughtObj;
	}
}
?>